Crashpad

Public Member Functions | List of all members
crashpad::internal::ThreadSnapshotWin Class Referencefinal

A ThreadSnapshot of a thread in a running (or crashed) process on a Windows system. More...

`#include "snapshot/win/thread_snapshot_win.h"`

Inheritance diagram for crashpad::internal::ThreadSnapshotWin:

## Public Member Functions
bool | Initialize (ProcessReaderWin *process_reader, const ProcessReaderWin::Thread &process_reader_thread, uint32_t *gather_indirectly_referenced_memory_bytes_remaining)
| Initializes the object. More...
const CPUContext * | Context () const override
| Returns a CPUContext object corresponding to the thread’s CPU context. More...
const MemorySnapshot * | Stack () const override
| Returns a MemorySnapshot object corresponding to the memory region that contains the thread’s stack, or `nullptr` if no stack region is available. More...
uint64_t | ThreadID () const override
| Returns the thread’s identifier. More...
int | SuspendCount () const override
| Returns the thread’s suspend count. More...
int | Priority () const override
| Returns the thread’s priority. More...
uint64_t | ThreadSpecificDataAddress () const override
| Returns the base address of a region used to store thread-specific data.
std::vector< const MemorySnapshot * > | ExtraMemory () const override
| Returns a vector of additional memory blocks that should be included in a minidump. More...

## Detailed Description

A ThreadSnapshot of a thread in a running (or crashed) process on a Windows system.

## Member Function Documentation

## ◆ Context()

const CPUContext * crashpad::internal::ThreadSnapshotWin::Context | ( |  | ) | const
| override virtual

Returns a CPUContext object corresponding to the thread’s CPU context.

The caller does not take ownership of this object, it is scoped to the lifetime of the ThreadSnapshot object that it was obtained from.

Implements crashpad::ThreadSnapshot.

## ◆ ExtraMemory()

std::vector< const MemorySnapshot * > crashpad::internal::ThreadSnapshotWin::ExtraMemory | ( |  | ) | const
| override virtual

Returns a vector of additional memory blocks that should be included in a minidump.

Returns
  A vector of MemorySnapshot objects that will be included in the crash dump. The caller does not take ownership of these objects, they are scoped to the lifetime of the ThreadSnapshot object that they were obtained from.

Implements crashpad::ThreadSnapshot.

## ◆ Initialize()

bool crashpad::internal::ThreadSnapshotWin::Initialize | ( | ProcessReaderWin * | process_reader,
|  | const ProcessReaderWin::Thread & | process_reader_thread,
|  | uint32_t * | gather_indirectly_referenced_memory_bytes_remaining
| ) |  |

Initializes the object.

Parameters

  [in] | process_reader | A ProcessReaderWin for the process containing the thread.
  [in] | process_reader_thread | The thread within the ProcessReaderWin for which the snapshot should be created.
  [in,out] | gather_indirectly_referenced_memory_bytes_remaining | If non-null, add extra memory regions to the snapshot pointed to by the thread's stack. The size of the regions added is subtracted from the count, and when it's `0`, no more regions will be added.

Returns
  `true` if the snapshot could be created, `false` otherwise with an appropriate message logged.

## ◆ Priority()

int crashpad::internal::ThreadSnapshotWin::Priority | ( |  | ) | const
| override virtual

Returns the thread’s priority.

Threads with higher priorities will have higher priority values.

Implements crashpad::ThreadSnapshot.

## ◆ Stack()

const MemorySnapshot * crashpad::internal::ThreadSnapshotWin::Stack | ( |  | ) | const
| override virtual

Returns a MemorySnapshot object corresponding to the memory region that contains the thread’s stack, or `nullptr` if no stack region is available.

The caller does not take ownership of this object, it is scoped to the lifetime of the ThreadSnapshot object that it was obtained from.

Implements crashpad::ThreadSnapshot.

## ◆ SuspendCount()

int crashpad::internal::ThreadSnapshotWin::SuspendCount | ( |  | ) | const
| override virtual

Returns the thread’s suspend count.

A suspend count of `0` denotes a schedulable (not suspended) thread.

Implements crashpad::ThreadSnapshot.

## ◆ ThreadID()

uint64_t crashpad::internal::ThreadSnapshotWin::ThreadID | ( |  | ) | const
| override virtual

Returns the thread’s identifier.

Thread identifiers are at least unique within a process, and may be unique system-wide.

Implements crashpad::ThreadSnapshot.

The documentation for this class was generated from the following files:

- snapshot/win/thread_snapshot_win.h
- snapshot/win/thread_snapshot_win.cc